(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: misc_sprint.mli,v 1.2 2014/06/30 13:57:24 fclement Exp $ *)

type 'a printer = 'a Format_printer.printer;;

type 'a string_printer = string -> 'a -> string;;
type ('a, 'b) string_printer_lifter = 'a printer -> 'b string_printer;;

val format_sprint : ('a, 'a) string_printer_lifter;;

val sprint_nat : Unatural.t string_printer;;
val sprint_float : float string_printer;;

val sprint_homogeneous_couple : ('a, 'a * 'a) string_printer_lifter;;
val sprint_array : ('a, 'a array) string_printer_lifter;;
val sprint_array_array : ('a, 'a array array) string_printer_lifter;;
val sprint_matrix : ('a, 'a Umatrix.t) string_printer_lifter;;

val sprint_nat_couple : (Unatural.t * Unatural.t) string_printer;;
val sprint_nat_matrix : Unatural.t Umatrix.t string_printer;;

val sprint_float_array_array : float array array string_printer;;
val sprint_float_matrix : float Umatrix.t string_printer;;
