(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: main.ml,v 1.12 2014/05/06 12:56:18 fclement Exp $ *)

module Cmd_opt = Ucommand_option;;

module Opt = Options;;
module Config = Configuration;;

let main () =
  Cmd_opt.parse_phase Opt.phase_dimension;
  let dim = Opt.get_option_dimension () in
  let module Comps = (val Components.vector_of_nat (Unatural.of_int dim)) in
  let module S = Refinement.Make (Scalar.Float) (Comps) in
  S.algorithm ();
  if Config.get_report_allocated_memory () then
    begin
      let ppf = Config.get_formatter () in
      let (tam, mu) = Monitor.total_allocated_memory () in
      Format.fprintf ppf "@.Total allocated memory: %g %s@." tam mu;
    end;
  exit 0;
;;

main ();;
