(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright (c) 2013-2014 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_size ppf = function
  | u_s -> Umatrix_universe_print.print_size ppf u_s
;;

let print_element ppf = function
  | u_e -> Umatrix_universe_print.print_element ppf u_e
;;

let print_uindex ppf = function
  | u_i -> Umatrix_universe_print.print_index ppf u_i
;;

let print_index ppf = function
  | e_u_i -> Uindex_universe_print.print_index print_element ppf e_u_i
;;

let print_t ppf = function
  | {
      Umatrix_nonempty_set.universe = u_t;
      Umatrix_nonempty_set.uindices = e_u_t;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Format.fprintf ppf "%,@[<1>universe =@ ";
    Umatrix_universe_print.print_t ppf u_t; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>uindices =@ ";
    Uindex_universe_print.print_t print_element ppf e_u_t;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_nonempty_subset ppf = function
  | {
      Umatrix_nonempty_set.support = t;
      Umatrix_nonempty_set.indices = i_a;
      Umatrix_nonempty_set.nonempty_set = t0;
    } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>support =@ ";
    print_t ppf t; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>indices =@ ";
    Lib_print.print_Array print_index ppf i_a; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>nonempty_set =@ "; print_t ppf t0;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_dichotomy ppf = function
  | (n, n0) ->
    Format.fprintf ppf "%,@[<1>(@,"; print_nonempty_subset ppf n;
    Format.fprintf ppf "%,,@ "; print_nonempty_subset ppf n0;
    Format.fprintf ppf "%,@,)@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
